package com.zipcodewilmington;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {

        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array)
    {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array)
    {
        return array[array.length -1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array)
    {
        return array[array.length -2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
       /*boolean result= false;
        for(int i=0; i<array.length;i++)
        {
            if (array[i].equals(value) )
            {
                 result=true;
            }
            else
                {
                     result=  false;
                }
        }
        return result;*/

        boolean result  = Arrays.stream(array).anyMatch(value :: equals);
       return result;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String[] result =new String[array.length];
        int j=0;

        for(int i =array.length-1; i>=0; i--)
        {
            result[j]=  array[i];
            j++;
        }


        return result;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        boolean result = false;
        if ((array.length % 2) == 0)
        {
            for (int i = 0; i <= array.length - 1; i++)
            {
                if (array[i] == array[array.length - i - 1])
                {
                    result = true;
                } else
                    {
                    result = false;
                }
            }
        }
        else// odd
            {
            for (int i = 0; i <= (array.length - 1) / 2 - 1; i++) {
                if (array[i] == array[array.length - i - 1]) {
                    result = true;
                } else {
                    result = false;
                }
            }

        }
        return result;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        boolean result =true;
        String lower="";
        for(String var :array)
        {
            lower= lower.concat(var.toLowerCase());
        }
        for(int i=97;i<=122;i++)
        {
            if(!lower.contains(Character.toString((char)i))){
                result=false;
            }
        }


        return result;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value)
    {
        int count=0;
        for(int i=0; i<array.length;i++)
        {
            if(array[i]== value)
            {
                count=count+1;
            }
        }
        return count;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        String[] result =new String[array.length];
        int len=0;
        for(int i=0;i<array.length;i++)
        {
            if(!valueToRemove.equals(array[i]))
            {
                result[len]=array[i];
                len++;

            }

        }
        return Arrays.copyOf(result, len);
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        ArrayList <String> result=new ArrayList <String> ();
        for(int i=1;i<array.length;i++)
        {
            if(i+1<array.length && (array[i].equals(array[i+1])))
            {
                continue;
            }
            else
                {
                    result.add(array[i]);
                }
        }

        String[] newList= result.toArray(new String[result.size()]);


        return newList;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {

        ArrayList<String> s = new ArrayList<String>();
        StringBuffer tempB= new StringBuffer();
        boolean flag= false;
        int i=0;
        while(i<(array.length)-1){
            if(array[i].equalsIgnoreCase(array[i+1])){
                flag=true;
                tempB.append(array[i]);
            }
            else{
                if (flag==true) {
                    tempB.append(array[i]);
                    s.add(tempB.toString());
                    tempB = new StringBuffer("");
                }
                else{
                    s.add(array[i]);
                }
                flag=false;

                }
                i++;
            }
        if (flag==true) {
            tempB.append(array[i]);
            s.add(tempB.toString());
            tempB = new StringBuffer("");
        }
        else{
            s.add(array[i]);
        }


            String[] result= s.toArray(new String[s.size()]);
        System.out.println(result);
            return result;
        }


    }



